// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from etsi_its_cpm_ts_msgs:msg/CpmContainers.idl
// generated code does not contain a copyright notice
#include "etsi_its_cpm_ts_msgs/msg/detail/cpm_containers__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `choice`
#include "etsi_its_cpm_ts_msgs/msg/detail/cpm_container_id__functions.h"
// Member `originating_vehicle_container`
#include "etsi_its_cpm_ts_msgs/msg/detail/originating_vehicle_container__functions.h"
// Member `originating_rsu_container`
#include "etsi_its_cpm_ts_msgs/msg/detail/originating_rsu_container__functions.h"
// Member `sensor_information_container`
#include "etsi_its_cpm_ts_msgs/msg/detail/sensor_information_container__functions.h"
// Member `perception_region_container`
#include "etsi_its_cpm_ts_msgs/msg/detail/perception_region_container__functions.h"
// Member `perceived_object_container`
#include "etsi_its_cpm_ts_msgs/msg/detail/perceived_object_container__functions.h"

bool
etsi_its_cpm_ts_msgs__msg__CpmContainers__init(etsi_its_cpm_ts_msgs__msg__CpmContainers * msg)
{
  if (!msg) {
    return false;
  }
  // choice
  if (!etsi_its_cpm_ts_msgs__msg__CpmContainerId__init(&msg->choice)) {
    etsi_its_cpm_ts_msgs__msg__CpmContainers__fini(msg);
    return false;
  }
  // originating_vehicle_container
  if (!etsi_its_cpm_ts_msgs__msg__OriginatingVehicleContainer__init(&msg->originating_vehicle_container)) {
    etsi_its_cpm_ts_msgs__msg__CpmContainers__fini(msg);
    return false;
  }
  // originating_rsu_container
  if (!etsi_its_cpm_ts_msgs__msg__OriginatingRsuContainer__init(&msg->originating_rsu_container)) {
    etsi_its_cpm_ts_msgs__msg__CpmContainers__fini(msg);
    return false;
  }
  // sensor_information_container
  if (!etsi_its_cpm_ts_msgs__msg__SensorInformationContainer__init(&msg->sensor_information_container)) {
    etsi_its_cpm_ts_msgs__msg__CpmContainers__fini(msg);
    return false;
  }
  // perception_region_container
  if (!etsi_its_cpm_ts_msgs__msg__PerceptionRegionContainer__init(&msg->perception_region_container)) {
    etsi_its_cpm_ts_msgs__msg__CpmContainers__fini(msg);
    return false;
  }
  // perceived_object_container
  if (!etsi_its_cpm_ts_msgs__msg__PerceivedObjectContainer__init(&msg->perceived_object_container)) {
    etsi_its_cpm_ts_msgs__msg__CpmContainers__fini(msg);
    return false;
  }
  return true;
}

void
etsi_its_cpm_ts_msgs__msg__CpmContainers__fini(etsi_its_cpm_ts_msgs__msg__CpmContainers * msg)
{
  if (!msg) {
    return;
  }
  // choice
  etsi_its_cpm_ts_msgs__msg__CpmContainerId__fini(&msg->choice);
  // originating_vehicle_container
  etsi_its_cpm_ts_msgs__msg__OriginatingVehicleContainer__fini(&msg->originating_vehicle_container);
  // originating_rsu_container
  etsi_its_cpm_ts_msgs__msg__OriginatingRsuContainer__fini(&msg->originating_rsu_container);
  // sensor_information_container
  etsi_its_cpm_ts_msgs__msg__SensorInformationContainer__fini(&msg->sensor_information_container);
  // perception_region_container
  etsi_its_cpm_ts_msgs__msg__PerceptionRegionContainer__fini(&msg->perception_region_container);
  // perceived_object_container
  etsi_its_cpm_ts_msgs__msg__PerceivedObjectContainer__fini(&msg->perceived_object_container);
}

bool
etsi_its_cpm_ts_msgs__msg__CpmContainers__are_equal(const etsi_its_cpm_ts_msgs__msg__CpmContainers * lhs, const etsi_its_cpm_ts_msgs__msg__CpmContainers * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // choice
  if (!etsi_its_cpm_ts_msgs__msg__CpmContainerId__are_equal(
      &(lhs->choice), &(rhs->choice)))
  {
    return false;
  }
  // originating_vehicle_container
  if (!etsi_its_cpm_ts_msgs__msg__OriginatingVehicleContainer__are_equal(
      &(lhs->originating_vehicle_container), &(rhs->originating_vehicle_container)))
  {
    return false;
  }
  // originating_rsu_container
  if (!etsi_its_cpm_ts_msgs__msg__OriginatingRsuContainer__are_equal(
      &(lhs->originating_rsu_container), &(rhs->originating_rsu_container)))
  {
    return false;
  }
  // sensor_information_container
  if (!etsi_its_cpm_ts_msgs__msg__SensorInformationContainer__are_equal(
      &(lhs->sensor_information_container), &(rhs->sensor_information_container)))
  {
    return false;
  }
  // perception_region_container
  if (!etsi_its_cpm_ts_msgs__msg__PerceptionRegionContainer__are_equal(
      &(lhs->perception_region_container), &(rhs->perception_region_container)))
  {
    return false;
  }
  // perceived_object_container
  if (!etsi_its_cpm_ts_msgs__msg__PerceivedObjectContainer__are_equal(
      &(lhs->perceived_object_container), &(rhs->perceived_object_container)))
  {
    return false;
  }
  return true;
}

bool
etsi_its_cpm_ts_msgs__msg__CpmContainers__copy(
  const etsi_its_cpm_ts_msgs__msg__CpmContainers * input,
  etsi_its_cpm_ts_msgs__msg__CpmContainers * output)
{
  if (!input || !output) {
    return false;
  }
  // choice
  if (!etsi_its_cpm_ts_msgs__msg__CpmContainerId__copy(
      &(input->choice), &(output->choice)))
  {
    return false;
  }
  // originating_vehicle_container
  if (!etsi_its_cpm_ts_msgs__msg__OriginatingVehicleContainer__copy(
      &(input->originating_vehicle_container), &(output->originating_vehicle_container)))
  {
    return false;
  }
  // originating_rsu_container
  if (!etsi_its_cpm_ts_msgs__msg__OriginatingRsuContainer__copy(
      &(input->originating_rsu_container), &(output->originating_rsu_container)))
  {
    return false;
  }
  // sensor_information_container
  if (!etsi_its_cpm_ts_msgs__msg__SensorInformationContainer__copy(
      &(input->sensor_information_container), &(output->sensor_information_container)))
  {
    return false;
  }
  // perception_region_container
  if (!etsi_its_cpm_ts_msgs__msg__PerceptionRegionContainer__copy(
      &(input->perception_region_container), &(output->perception_region_container)))
  {
    return false;
  }
  // perceived_object_container
  if (!etsi_its_cpm_ts_msgs__msg__PerceivedObjectContainer__copy(
      &(input->perceived_object_container), &(output->perceived_object_container)))
  {
    return false;
  }
  return true;
}

etsi_its_cpm_ts_msgs__msg__CpmContainers *
etsi_its_cpm_ts_msgs__msg__CpmContainers__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cpm_ts_msgs__msg__CpmContainers * msg = (etsi_its_cpm_ts_msgs__msg__CpmContainers *)allocator.allocate(sizeof(etsi_its_cpm_ts_msgs__msg__CpmContainers), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(etsi_its_cpm_ts_msgs__msg__CpmContainers));
  bool success = etsi_its_cpm_ts_msgs__msg__CpmContainers__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
etsi_its_cpm_ts_msgs__msg__CpmContainers__destroy(etsi_its_cpm_ts_msgs__msg__CpmContainers * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    etsi_its_cpm_ts_msgs__msg__CpmContainers__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
etsi_its_cpm_ts_msgs__msg__CpmContainers__Sequence__init(etsi_its_cpm_ts_msgs__msg__CpmContainers__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cpm_ts_msgs__msg__CpmContainers * data = NULL;

  if (size) {
    data = (etsi_its_cpm_ts_msgs__msg__CpmContainers *)allocator.zero_allocate(size, sizeof(etsi_its_cpm_ts_msgs__msg__CpmContainers), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = etsi_its_cpm_ts_msgs__msg__CpmContainers__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        etsi_its_cpm_ts_msgs__msg__CpmContainers__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
etsi_its_cpm_ts_msgs__msg__CpmContainers__Sequence__fini(etsi_its_cpm_ts_msgs__msg__CpmContainers__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      etsi_its_cpm_ts_msgs__msg__CpmContainers__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

etsi_its_cpm_ts_msgs__msg__CpmContainers__Sequence *
etsi_its_cpm_ts_msgs__msg__CpmContainers__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cpm_ts_msgs__msg__CpmContainers__Sequence * array = (etsi_its_cpm_ts_msgs__msg__CpmContainers__Sequence *)allocator.allocate(sizeof(etsi_its_cpm_ts_msgs__msg__CpmContainers__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = etsi_its_cpm_ts_msgs__msg__CpmContainers__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
etsi_its_cpm_ts_msgs__msg__CpmContainers__Sequence__destroy(etsi_its_cpm_ts_msgs__msg__CpmContainers__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    etsi_its_cpm_ts_msgs__msg__CpmContainers__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
etsi_its_cpm_ts_msgs__msg__CpmContainers__Sequence__are_equal(const etsi_its_cpm_ts_msgs__msg__CpmContainers__Sequence * lhs, const etsi_its_cpm_ts_msgs__msg__CpmContainers__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!etsi_its_cpm_ts_msgs__msg__CpmContainers__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
etsi_its_cpm_ts_msgs__msg__CpmContainers__Sequence__copy(
  const etsi_its_cpm_ts_msgs__msg__CpmContainers__Sequence * input,
  etsi_its_cpm_ts_msgs__msg__CpmContainers__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(etsi_its_cpm_ts_msgs__msg__CpmContainers);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    etsi_its_cpm_ts_msgs__msg__CpmContainers * data =
      (etsi_its_cpm_ts_msgs__msg__CpmContainers *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!etsi_its_cpm_ts_msgs__msg__CpmContainers__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          etsi_its_cpm_ts_msgs__msg__CpmContainers__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!etsi_its_cpm_ts_msgs__msg__CpmContainers__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
